###############################################################################
#
# Bash remediation role for profile anssi_np_nt28_restrictive
# Profile Title:  Profile for ANSSI DAT-NT28 Restrictive Level
# Profile Description:
# This profile contains items for GNU/Linux installations exposed to unauthenticated flows or multiple sources.
#
# Benchmark ID:  UBUNTU-TRUSTY
# Benchmark Version:  0.1.44
#
# XCCDF Version:  1.1
#
# This file was generated by OpenSCAP 1.2.17 using:
# 	$ oscap xccdf generate fix --profile anssi_np_nt28_restrictive --template urn:xccdf:fix:script:sh xccdf-file.xml 
#
# This script is generated from an OpenSCAP profile without preliminary evaluation.
# It attempts to fix every selected rule, even if the system is already compliant.
#
# How to apply this remediation role:
# $ sudo ./remediation-role.sh
#
###############################################################################

###############################################################################
# BEGIN fix (1 / 44) for 'package_cron_installed'
###############################################################################
(>&2 echo "Remediating rule 1/44: 'package_cron_installed'")
(>&2 echo "FIX FOR THIS RULE 'package_cron_installed' IS MISSING!")
# END fix for 'package_cron_installed'

###############################################################################
# BEGIN fix (2 / 44) for 'sshd_disable_empty_passwords'
###############################################################################
(>&2 echo "Remediating rule 2/44: 'sshd_disable_empty_passwords'")
(>&2 echo "FIX FOR THIS RULE 'sshd_disable_empty_passwords' IS MISSING!")
# END fix for 'sshd_disable_empty_passwords'

###############################################################################
# BEGIN fix (3 / 44) for 'sshd_allow_only_protocol2'
###############################################################################
(>&2 echo "Remediating rule 3/44: 'sshd_allow_only_protocol2'")
(>&2 echo "FIX FOR THIS RULE 'sshd_allow_only_protocol2' IS MISSING!")
# END fix for 'sshd_allow_only_protocol2'

###############################################################################
# BEGIN fix (4 / 44) for 'sshd_set_keepalive'
###############################################################################
(>&2 echo "Remediating rule 4/44: 'sshd_set_keepalive'")
(>&2 echo "FIX FOR THIS RULE 'sshd_set_keepalive' IS MISSING!")
# END fix for 'sshd_set_keepalive'

###############################################################################
# BEGIN fix (5 / 44) for 'sshd_disable_root_login'
###############################################################################
(>&2 echo "Remediating rule 5/44: 'sshd_disable_root_login'")
(>&2 echo "FIX FOR THIS RULE 'sshd_disable_root_login' IS MISSING!")
# END fix for 'sshd_disable_root_login'

###############################################################################
# BEGIN fix (6 / 44) for 'sshd_set_idle_timeout'
###############################################################################
(>&2 echo "Remediating rule 6/44: 'sshd_set_idle_timeout'")
(>&2 echo "FIX FOR THIS RULE 'sshd_set_idle_timeout' IS MISSING!")
# END fix for 'sshd_set_idle_timeout'

###############################################################################
# BEGIN fix (7 / 44) for 'package_ntp_installed'
###############################################################################
(>&2 echo "Remediating rule 7/44: 'package_ntp_installed'")
(>&2 echo "FIX FOR THIS RULE 'package_ntp_installed' IS MISSING!")
# END fix for 'package_ntp_installed'

###############################################################################
# BEGIN fix (8 / 44) for 'service_ntp_enabled'
###############################################################################
(>&2 echo "Remediating rule 8/44: 'service_ntp_enabled'")
(>&2 echo "FIX FOR THIS RULE 'service_ntp_enabled' IS MISSING!")
# END fix for 'service_ntp_enabled'

###############################################################################
# BEGIN fix (9 / 44) for 'apt_conf_disallow_unauthenticated'
###############################################################################
(>&2 echo "Remediating rule 9/44: 'apt_conf_disallow_unauthenticated'")
(>&2 echo "FIX FOR THIS RULE 'apt_conf_disallow_unauthenticated' IS MISSING!")
# END fix for 'apt_conf_disallow_unauthenticated'

###############################################################################
# BEGIN fix (10 / 44) for 'package_ntpdate_removed'
###############################################################################
(>&2 echo "Remediating rule 10/44: 'package_ntpdate_removed'")
# Function to remove packages on RHEL, Fedora, Debian, and possibly other systems.
#
# Example Call(s):
#
#     package_remove telnet-server
#
function package_remove {

# Load function arguments into local variables
local package="$1"

# Check sanity of the input
if [ $# -ne "1" ]
then
  echo "Usage: package_remove 'package_name'"
  echo "Aborting."
  exit 1
fi

if which dnf ; then
  if rpm -q --quiet "$package"; then
    dnf remove -y "$package"
  fi
elif which yum ; then
  if rpm -q --quiet "$package"; then
    yum remove -y "$package"
  fi
elif which apt-get ; then
  apt-get remove -y "$package"
else
  echo "Failed to detect available packaging system, tried dnf, yum and apt-get!"
  echo "Aborting."
  exit 1
fi

}

package_remove ntpdate
# END fix for 'package_ntpdate_removed'

###############################################################################
# BEGIN fix (11 / 44) for 'package_telnetd_removed'
###############################################################################
(>&2 echo "Remediating rule 11/44: 'package_telnetd_removed'")
# Function to remove packages on RHEL, Fedora, Debian, and possibly other systems.
#
# Example Call(s):
#
#     package_remove telnet-server
#
function package_remove {

# Load function arguments into local variables
local package="$1"

# Check sanity of the input
if [ $# -ne "1" ]
then
  echo "Usage: package_remove 'package_name'"
  echo "Aborting."
  exit 1
fi

if which dnf ; then
  if rpm -q --quiet "$package"; then
    dnf remove -y "$package"
  fi
elif which yum ; then
  if rpm -q --quiet "$package"; then
    yum remove -y "$package"
  fi
elif which apt-get ; then
  apt-get remove -y "$package"
else
  echo "Failed to detect available packaging system, tried dnf, yum and apt-get!"
  echo "Aborting."
  exit 1
fi

}

package_remove telnetd
# END fix for 'package_telnetd_removed'

###############################################################################
# BEGIN fix (12 / 44) for 'package_telnetd-ssl_removed'
###############################################################################
(>&2 echo "Remediating rule 12/44: 'package_telnetd-ssl_removed'")
# Function to remove packages on RHEL, Fedora, Debian, and possibly other systems.
#
# Example Call(s):
#
#     package_remove telnet-server
#
function package_remove {

# Load function arguments into local variables
local package="$1"

# Check sanity of the input
if [ $# -ne "1" ]
then
  echo "Usage: package_remove 'package_name'"
  echo "Aborting."
  exit 1
fi

if which dnf ; then
  if rpm -q --quiet "$package"; then
    dnf remove -y "$package"
  fi
elif which yum ; then
  if rpm -q --quiet "$package"; then
    yum remove -y "$package"
  fi
elif which apt-get ; then
  apt-get remove -y "$package"
else
  echo "Failed to detect available packaging system, tried dnf, yum and apt-get!"
  echo "Aborting."
  exit 1
fi

}

package_remove telnetd-ssl
# END fix for 'package_telnetd-ssl_removed'

###############################################################################
# BEGIN fix (13 / 44) for 'package_inetutils-telnetd_removed'
###############################################################################
(>&2 echo "Remediating rule 13/44: 'package_inetutils-telnetd_removed'")
# Function to remove packages on RHEL, Fedora, Debian, and possibly other systems.
#
# Example Call(s):
#
#     package_remove telnet-server
#
function package_remove {

# Load function arguments into local variables
local package="$1"

# Check sanity of the input
if [ $# -ne "1" ]
then
  echo "Usage: package_remove 'package_name'"
  echo "Aborting."
  exit 1
fi

if which dnf ; then
  if rpm -q --quiet "$package"; then
    dnf remove -y "$package"
  fi
elif which yum ; then
  if rpm -q --quiet "$package"; then
    yum remove -y "$package"
  fi
elif which apt-get ; then
  apt-get remove -y "$package"
else
  echo "Failed to detect available packaging system, tried dnf, yum and apt-get!"
  echo "Aborting."
  exit 1
fi

}

package_remove inetutils-telnetd
# END fix for 'package_inetutils-telnetd_removed'

###############################################################################
# BEGIN fix (14 / 44) for 'package_nis_removed'
###############################################################################
(>&2 echo "Remediating rule 14/44: 'package_nis_removed'")
# Function to remove packages on RHEL, Fedora, Debian, and possibly other systems.
#
# Example Call(s):
#
#     package_remove telnet-server
#
function package_remove {

# Load function arguments into local variables
local package="$1"

# Check sanity of the input
if [ $# -ne "1" ]
then
  echo "Usage: package_remove 'package_name'"
  echo "Aborting."
  exit 1
fi

if which dnf ; then
  if rpm -q --quiet "$package"; then
    dnf remove -y "$package"
  fi
elif which yum ; then
  if rpm -q --quiet "$package"; then
    yum remove -y "$package"
  fi
elif which apt-get ; then
  apt-get remove -y "$package"
else
  echo "Failed to detect available packaging system, tried dnf, yum and apt-get!"
  echo "Aborting."
  exit 1
fi

}

package_remove nis
# END fix for 'package_nis_removed'

###############################################################################
# BEGIN fix (15 / 44) for 'service_auditd_enabled'
###############################################################################
(>&2 echo "Remediating rule 15/44: 'service_auditd_enabled'")
(>&2 echo "FIX FOR THIS RULE 'service_auditd_enabled' IS MISSING!")
# END fix for 'service_auditd_enabled'

###############################################################################
# BEGIN fix (16 / 44) for 'package_auditd_installed'
###############################################################################
(>&2 echo "Remediating rule 16/44: 'package_auditd_installed'")
(>&2 echo "FIX FOR THIS RULE 'package_auditd_installed' IS MISSING!")
# END fix for 'package_auditd_installed'

###############################################################################
# BEGIN fix (17 / 44) for 'ensure_logrotate_activated'
###############################################################################
(>&2 echo "Remediating rule 17/44: 'ensure_logrotate_activated'")

LOGROTATE_CONF_FILE="/etc/logrotate.conf"
CRON_DAILY_LOGROTATE_FILE="/etc/cron.daily/logrotate"

# daily rotation is configured
grep -q "^daily$" $LOGROTATE_CONF_FILE|| echo "daily" >> $LOGROTATE_CONF_FILE

# remove any line configuring weekly, monthly or yearly rotation
sed -i -r "/^(weekly|monthly|yearly)$/d" $LOGROTATE_CONF_FILE

# configure cron.daily if not already
if ! grep -q "^[[:space:]]*/usr/sbin/logrotate[[:alnum:][:blank:][:punct:]]*$LOGROTATE_CONF_FILE$" $CRON_DAILY_LOGROTATE_FILE; then
	echo "#!/bin/sh" > $CRON_DAILY_LOGROTATE_FILE
	echo "/usr/sbin/logrotate $LOGROTATE_CONF_FILE" >> $CRON_DAILY_LOGROTATE_FILE
fi
# END fix for 'ensure_logrotate_activated'

###############################################################################
# BEGIN fix (18 / 44) for 'rsyslog_files_permissions'
###############################################################################
(>&2 echo "Remediating rule 18/44: 'rsyslog_files_permissions'")
(>&2 echo "FIX FOR THIS RULE 'rsyslog_files_permissions' IS MISSING!")
# END fix for 'rsyslog_files_permissions'

###############################################################################
# BEGIN fix (19 / 44) for 'rsyslog_files_groupownership'
###############################################################################
(>&2 echo "Remediating rule 19/44: 'rsyslog_files_groupownership'")
(>&2 echo "FIX FOR THIS RULE 'rsyslog_files_groupownership' IS MISSING!")
# END fix for 'rsyslog_files_groupownership'

###############################################################################
# BEGIN fix (20 / 44) for 'rsyslog_files_ownership'
###############################################################################
(>&2 echo "Remediating rule 20/44: 'rsyslog_files_ownership'")
(>&2 echo "FIX FOR THIS RULE 'rsyslog_files_ownership' IS MISSING!")
# END fix for 'rsyslog_files_ownership'

###############################################################################
# BEGIN fix (21 / 44) for 'sudo_remove_no_authenticate'
###############################################################################
(>&2 echo "Remediating rule 21/44: 'sudo_remove_no_authenticate'")
(>&2 echo "FIX FOR THIS RULE 'sudo_remove_no_authenticate' IS MISSING!")
# END fix for 'sudo_remove_no_authenticate'

###############################################################################
# BEGIN fix (22 / 44) for 'sudo_remove_nopasswd'
###############################################################################
(>&2 echo "Remediating rule 22/44: 'sudo_remove_nopasswd'")
(>&2 echo "FIX FOR THIS RULE 'sudo_remove_nopasswd' IS MISSING!")
# END fix for 'sudo_remove_nopasswd'

###############################################################################
# BEGIN fix (23 / 44) for 'partition_for_tmp'
###############################################################################
(>&2 echo "Remediating rule 23/44: 'partition_for_tmp'")
(>&2 echo "FIX FOR THIS RULE 'partition_for_tmp' IS MISSING!")
# END fix for 'partition_for_tmp'

###############################################################################
# BEGIN fix (24 / 44) for 'partition_for_var'
###############################################################################
(>&2 echo "Remediating rule 24/44: 'partition_for_var'")
(>&2 echo "FIX FOR THIS RULE 'partition_for_var' IS MISSING!")
# END fix for 'partition_for_var'

###############################################################################
# BEGIN fix (25 / 44) for 'partition_for_var_log'
###############################################################################
(>&2 echo "Remediating rule 25/44: 'partition_for_var_log'")
(>&2 echo "FIX FOR THIS RULE 'partition_for_var_log' IS MISSING!")
# END fix for 'partition_for_var_log'

###############################################################################
# BEGIN fix (26 / 44) for 'partition_for_home'
###############################################################################
(>&2 echo "Remediating rule 26/44: 'partition_for_home'")
(>&2 echo "FIX FOR THIS RULE 'partition_for_home' IS MISSING!")
# END fix for 'partition_for_home'

###############################################################################
# BEGIN fix (27 / 44) for 'partition_for_var_log_audit'
###############################################################################
(>&2 echo "Remediating rule 27/44: 'partition_for_var_log_audit'")
(>&2 echo "FIX FOR THIS RULE 'partition_for_var_log_audit' IS MISSING!")
# END fix for 'partition_for_var_log_audit'

###############################################################################
# BEGIN fix (28 / 44) for 'file_groupowner_etc_shadow'
###############################################################################
(>&2 echo "Remediating rule 28/44: 'file_groupowner_etc_shadow'")

chgrp 42 /etc/shadow
# END fix for 'file_groupowner_etc_shadow'

###############################################################################
# BEGIN fix (29 / 44) for 'file_groupowner_etc_passwd'
###############################################################################
(>&2 echo "Remediating rule 29/44: 'file_groupowner_etc_passwd'")

chgrp 0 /etc/passwd
# END fix for 'file_groupowner_etc_passwd'

###############################################################################
# BEGIN fix (30 / 44) for 'file_groupowner_etc_group'
###############################################################################
(>&2 echo "Remediating rule 30/44: 'file_groupowner_etc_group'")

chgrp 0 /etc/group
# END fix for 'file_groupowner_etc_group'

###############################################################################
# BEGIN fix (31 / 44) for 'file_permissions_etc_gshadow'
###############################################################################
(>&2 echo "Remediating rule 31/44: 'file_permissions_etc_gshadow'")

chmod 0640 /etc/gshadow
# END fix for 'file_permissions_etc_gshadow'

###############################################################################
# BEGIN fix (32 / 44) for 'file_owner_etc_shadow'
###############################################################################
(>&2 echo "Remediating rule 32/44: 'file_owner_etc_shadow'")

chown 0 /etc/shadow
# END fix for 'file_owner_etc_shadow'

###############################################################################
# BEGIN fix (33 / 44) for 'file_permissions_etc_shadow'
###############################################################################
(>&2 echo "Remediating rule 33/44: 'file_permissions_etc_shadow'")

chmod 0640 /etc/shadow
# END fix for 'file_permissions_etc_shadow'

###############################################################################
# BEGIN fix (34 / 44) for 'file_owner_etc_group'
###############################################################################
(>&2 echo "Remediating rule 34/44: 'file_owner_etc_group'")

chown 0 /etc/group
# END fix for 'file_owner_etc_group'

###############################################################################
# BEGIN fix (35 / 44) for 'file_permissions_etc_group'
###############################################################################
(>&2 echo "Remediating rule 35/44: 'file_permissions_etc_group'")

chmod 0644 /etc/group
# END fix for 'file_permissions_etc_group'

###############################################################################
# BEGIN fix (36 / 44) for 'file_owner_etc_passwd'
###############################################################################
(>&2 echo "Remediating rule 36/44: 'file_owner_etc_passwd'")

chown 0 /etc/passwd
# END fix for 'file_owner_etc_passwd'

###############################################################################
# BEGIN fix (37 / 44) for 'file_groupowner_etc_gshadow'
###############################################################################
(>&2 echo "Remediating rule 37/44: 'file_groupowner_etc_gshadow'")

chgrp 42 /etc/gshadow
# END fix for 'file_groupowner_etc_gshadow'

###############################################################################
# BEGIN fix (38 / 44) for 'file_owner_etc_gshadow'
###############################################################################
(>&2 echo "Remediating rule 38/44: 'file_owner_etc_gshadow'")

chown 0 /etc/gshadow
# END fix for 'file_owner_etc_gshadow'

###############################################################################
# BEGIN fix (39 / 44) for 'file_permissions_etc_passwd'
###############################################################################
(>&2 echo "Remediating rule 39/44: 'file_permissions_etc_passwd'")

chmod 0644 /etc/passwd
# END fix for 'file_permissions_etc_passwd'

###############################################################################
# BEGIN fix (40 / 44) for 'file_permissions_systemmap'
###############################################################################
(>&2 echo "Remediating rule 40/44: 'file_permissions_systemmap'")
(>&2 echo "FIX FOR THIS RULE 'file_permissions_systemmap' IS MISSING!")
# END fix for 'file_permissions_systemmap'

###############################################################################
# BEGIN fix (41 / 44) for 'sysctl_fs_protected_symlinks'
###############################################################################
(>&2 echo "Remediating rule 41/44: 'sysctl_fs_protected_symlinks'")
(>&2 echo "FIX FOR THIS RULE 'sysctl_fs_protected_symlinks' IS MISSING!")
# END fix for 'sysctl_fs_protected_symlinks'

###############################################################################
# BEGIN fix (42 / 44) for 'sysctl_fs_protected_hardlinks'
###############################################################################
(>&2 echo "Remediating rule 42/44: 'sysctl_fs_protected_hardlinks'")
(>&2 echo "FIX FOR THIS RULE 'sysctl_fs_protected_hardlinks' IS MISSING!")
# END fix for 'sysctl_fs_protected_hardlinks'

###############################################################################
# BEGIN fix (43 / 44) for 'sysctl_kernel_randomize_va_space'
###############################################################################
(>&2 echo "Remediating rule 43/44: 'sysctl_kernel_randomize_va_space'")
(>&2 echo "FIX FOR THIS RULE 'sysctl_kernel_randomize_va_space' IS MISSING!")
# END fix for 'sysctl_kernel_randomize_va_space'

###############################################################################
# BEGIN fix (44 / 44) for 'sysctl_fs_suid_dumpable'
###############################################################################
(>&2 echo "Remediating rule 44/44: 'sysctl_fs_suid_dumpable'")
(>&2 echo "FIX FOR THIS RULE 'sysctl_fs_suid_dumpable' IS MISSING!")
# END fix for 'sysctl_fs_suid_dumpable'

